// Simple DDS
// 2015.8.23 Eleken (rev_c1815@yahoo.co.jp)
// See also: http://eleken.y-lab.org/

// MCU : ATtiny2313A
// main clock : 25.0 MHz (over-clocked)
// Fuse High: 0b11011011 
// Fuse Low : 0b11101111 

#include "main.h"
//#include "YSwitchProc.h"

/*** Grobal Variables / Macros ***/

uint8_t gSineTable[256] __attribute__ ((section (".sinetable"))) = 
{
#include "table.txt"
};

/*** Declare Function ***/
void DDSFunc(void); // assembly finctuion


/*** End of declare function ***/

/* EEPROM */

/*** ISR Functions ***/

/* UART */

/* Timer */

//ISR(TIM0_OVF_vect  ){
//}

/*** End of ISR Functions ***/

/* Common function on my projects... */

static void InitPort(void){
	
	// init clock
//	CLKPR = 0x80;
//	CLKPR = 0x00; // CLKPS = 0 (8MHz)
	
//	MCUSR = 0;
	
	// init pins
	DDRB  = 0b11111111;
	PORTB = 0b00000000;
	
	DDRD  = 0b00000000;
	PORTD = 0b01111111;
	
}
// Initialize
static void Init(void){
	
//	cli();
	
	InitPort();
	
	// init usart
	UCSRA = 0b00000010;
	UCSRB = 0b10010000;
	UCSRC = 0b00000110;
#define UBRR_VALUE ((F_CPU/8/19200) - 1) // 19.2k = fosc / 8(UBRR+1)
	// UBRR = fosc/8/19.2k - 1
	UBRRL  = LB(UBRR_VALUE); 
	UBRRH  = HB(UBRR_VALUE); 
	
//	sei();
	
}


int main(void)
{
	// 
	Init();
	
	
	DDSFunc();
	
	while(1){
		
	}
	

	return 0;
}
